/*
  File autogenerated by gengetopt version 2.10
  generated with the following command:
  gengetopt 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "getopt.h"

#include "cmdline.h"

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n"
  "Purpose:\n"
  "  ISDN Voice Box Answering Machine\n"
  "\n"
  "Usage: %s [OPTIONS]...\n", CMDLINE_PARSER_PACKAGE);
  printf("   -h         --help           Print help and exit\n");
  printf("   -V         --version        Print version and exit\n");
  printf("   -k         --kill           Kill a running daemon (default=off)\n");
  printf("   -n         --no-daemon      Do not daemonize (default=off)\n");
  printf("   -s         --no-syslog      Do not log to syslog (default=off)\n");
  printf("   -c         --check          Check if the daemon is currently running (default=off)\n");
  printf("   -CINT      --channels=INT   Specify how many channels to allocate, defaults to 2 (default='2')\n");
  printf("              --msntab=STRING  Specify non standard msntab file\n");
  printf("   -LSTRING   --listen=STRING  Specify a glob pattern matching the MSNs to listen on\n");
  printf("   -dSTRING   --device=STRING  Specify the devices to use\n");
  printf("              --no-drop-root   Do not drop root priviliges (default=off)\n");
  printf("              --reload         Tell a running instance to reload the MSN table (default=off)\n");
  printf("              --info           Tell a running ivamd to dump its MSN table to syslog (default=off)\n");
}


static char *gengetopt_strdup (const char *s);

/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->kill_given = 0 ;
  args_info->no_daemon_given = 0 ;
  args_info->no_syslog_given = 0 ;
  args_info->check_given = 0 ;
  args_info->channels_given = 0 ;
  args_info->msntab_given = 0 ;
  args_info->listen_given = 0 ;
  args_info->device_given = 0 ;
  args_info->no_drop_root_given = 0 ;
  args_info->reload_given = 0 ;
  args_info->info_given = 0 ;
#define clear_args() { \
  args_info->kill_flag = 0;\
  args_info->no_daemon_flag = 0;\
  args_info->no_syslog_flag = 0;\
  args_info->check_flag = 0;\
  args_info->channels_arg = 2 ;\
  args_info->msntab_arg = NULL; \
  args_info->listen_arg = NULL; \
  args_info->device_arg = NULL; \
  args_info->no_drop_root_flag = 0;\
  args_info->reload_flag = 0;\
  args_info->info_flag = 0;\
}

  clear_args();

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "kill",	0, NULL, 'k' },
        { "no-daemon",	0, NULL, 'n' },
        { "no-syslog",	0, NULL, 's' },
        { "check",	0, NULL, 'c' },
        { "channels",	1, NULL, 'C' },
        { "msntab",	1, NULL, 0 },
        { "listen",	1, NULL, 'L' },
        { "device",	1, NULL, 'd' },
        { "no-drop-root",	0, NULL, 0 },
        { "reload",	0, NULL, 0 },
        { "info",	0, NULL, 0 },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVknscC:L:d:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          cmdline_parser_print_help ();
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          cmdline_parser_print_version ();
          exit (EXIT_SUCCESS);

        case 'k':	/* Kill a running daemon.  */
          if (args_info->kill_given)
            {
              fprintf (stderr, "%s: `--kill' (`-k') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->kill_given = 1;
          args_info->kill_flag = !(args_info->kill_flag);
          break;

        case 'n':	/* Do not daemonize.  */
          if (args_info->no_daemon_given)
            {
              fprintf (stderr, "%s: `--no-daemon' (`-n') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->no_daemon_given = 1;
          args_info->no_daemon_flag = !(args_info->no_daemon_flag);
          break;

        case 's':	/* Do not log to syslog.  */
          if (args_info->no_syslog_given)
            {
              fprintf (stderr, "%s: `--no-syslog' (`-s') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->no_syslog_given = 1;
          args_info->no_syslog_flag = !(args_info->no_syslog_flag);
          break;

        case 'c':	/* Check if the daemon is currently running.  */
          if (args_info->check_given)
            {
              fprintf (stderr, "%s: `--check' (`-c') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->check_given = 1;
          args_info->check_flag = !(args_info->check_flag);
          break;

        case 'C':	/* Specify how many channels to allocate, defaults to 2.  */
          if (args_info->channels_given)
            {
              fprintf (stderr, "%s: `--channels' (`-C') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->channels_given = 1;
          args_info->channels_arg = strtol (optarg,&stop_char,0);
          break;

        case 'L':	/* Specify a glob pattern matching the MSNs to listen on.  */
          if (args_info->listen_given)
            {
              fprintf (stderr, "%s: `--listen' (`-L') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->listen_given = 1;
          args_info->listen_arg = gengetopt_strdup (optarg);
          break;

        case 'd':	/* Specify the devices to use.  */
          if (args_info->device_given)
            {
              fprintf (stderr, "%s: `--device' (`-d') option given more than once\n", CMDLINE_PARSER_PACKAGE);
              clear_args ();
              exit (EXIT_FAILURE);
            }
          args_info->device_given = 1;
          args_info->device_arg = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
          /* Specify non standard msntab file.  */
          if (strcmp (long_options[option_index].name, "msntab") == 0)
          {
            if (args_info->msntab_given)
              {
                fprintf (stderr, "%s: `--msntab' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->msntab_given = 1;
            args_info->msntab_arg = gengetopt_strdup (optarg);
            break;
          }
          
          /* Do not drop root priviliges.  */
          else if (strcmp (long_options[option_index].name, "no-drop-root") == 0)
          {
            if (args_info->no_drop_root_given)
              {
                fprintf (stderr, "%s: `--no-drop-root' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->no_drop_root_given = 1;
            args_info->no_drop_root_flag = !(args_info->no_drop_root_flag);
            break;
          }
          
          /* Tell a running instance to reload the MSN table.  */
          else if (strcmp (long_options[option_index].name, "reload") == 0)
          {
            if (args_info->reload_given)
              {
                fprintf (stderr, "%s: `--reload' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->reload_given = 1;
            args_info->reload_flag = !(args_info->reload_flag);
            break;
          }
          
          /* Tell a running ivamd to dump its MSN table to syslog.  */
          else if (strcmp (long_options[option_index].name, "info") == 0)
          {
            if (args_info->info_given)
              {
                fprintf (stderr, "%s: `--info' option given more than once\n", CMDLINE_PARSER_PACKAGE);
                clear_args ();
                exit (EXIT_FAILURE);
              }
            args_info->info_given = 1;
            args_info->info_flag = !(args_info->info_flag);
            break;
          }
          

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (EXIT_FAILURE);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", CMDLINE_PARSER_PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */


  if ( missing_required_options )
    exit (EXIT_FAILURE);

  return 0;
}
